//
// a 2 0 o n . c
//
// Enable A20 address line
//
// Sep. 14, 2002 by W.Nishida (http://www.skyfree.org)
//

#include "kbc.h"
#include "dos-console.h"

asm(".code16gcc");

int main(void) {
  int ret;

  // Ignore keyboard interrupts

  disable_keyint();			// Disable keyboard interruption

  // Read port2

  kbc_command(KBC_READ_PORT2);		// Read current port2 status
  ret = kbc_read();			// Grub the data

  // Update port2 with A20 bit on

  kbc_command(KBC_WRITE_PORT2);		// Write new value to port2
  kbc_write(ret | KBC_PORT2_A20);	// Turn on A20 control bit

  // Confirm updated status

  kbc_command(KBC_READ_PORT2);		// Reread port2 status
  ret = kbc_read();			// Grub the data

  // Reactivate keyboard interruption

  enable_keyint();

  prints("A20 line is now enabled.");
  return 0;
 }
